//*****************************************
// RTC & 7seg LED Program Mega88
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
//
//
//
//  2014/01/29  New(TAB4)  Taishi
//*****************************************


#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>
#include	<stdio.h>

#include	"RTC_7SEG.h"
#include	"uart.h"
#include	"Timer.h"
#include	"disp_7seg_led.h"
#include	"Rtc_DS3234.h"
#include	"port_bit.h"
#include	"Ad_conv.h"
#include	"utl.h"


unsigned char	num_data[5]={0x01,0x02,0x03,0x04,0};			// S̐f[^
unsigned char	dp_data[5] ={0x00,0x00,0x00,0x00,0};			// S̏_f[^

enum DISP_CLOCK_MODE {		// 샂[h
		HM = 0,				// \
		MD,					// \
		YE,					// N\
		A_D,				// `^c\
		SET					// v킹
	};

// **********************************************************
// ********************** Soft Timer ************************
// **********************************************************

volatile unsigned int	wait_i;
volatile unsigned int	wait_j;
volatile unsigned char	wait_us;
// ************************************
// Delay 2uS
// t: uS (max 255)
// CPU Clock:8.000MHz
//  while ߂ for ŎԂ킹Ă
// ************************************
void delay_2us(unsigned char t)
{
	unsigned char	i;

	for(i=0;i<t;i++){
		wait_us++;				// 1uS Delay??
		wait_us++;				// 1uS Delay??
		wait_us++;				// 1uS Delay??
	}
}
//***************************
// Wait
//  tm : Wait Time(ms) max. 8000
// CPU Clock:8.000MHz
//***************************
void	delay_ms(int tm)
{

	for(wait_i = 0; wait_i < tm; wait_i++){
		delay_2us(500/2);
		delay_2us(500/2);
	}
}
//***************************
//  Main
//***************************
int	main(void)
{

	char			uc;
	unsigned short	bright;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;
	unsigned short	old_AD_data = 0xffff;

	uart_init();										// UART Initial

	uart_tx_str_crlf(" ");								// UART TxD String + CR + LF
	uart_tx_str_crlf(__DATE__);							// UART TxD String + CR + LF
	uart_tx_str_crlf(__TIME__);							// UART TxD String + CR + LF
	uart_tx_str_crlf(__FILE__);							// UART TxD String + CR + LF

	uart_tx_str_crlf("Ecoh Start");						// UART TxD String + CR + LF

// VZO\
	init_7seg();										//  VZOp̏ݒ
	chang_7seg_data(num_data,dp_data);					//  VZOf[^֕ϊS
	set_7seg_enable();									//  VZO\̗L̃Zbg

	sw_init();											//@XCb`̏ݒ
	rtc_init();											//  qsb̏ݒ
	ad1_init();											// A/D 1 Initial
	Timer2_init();										// Timer2 Initial

	tim_10ms_led = 50;									// kdcpPOrPʃ^C}[
	sei();												// 荞݉

	while(1){
		if(Get_rxd((unsigned char *)(&uc)) != 0){				// MiGR[obNj
			uart_tx_one(uc);									// UART TxD One Char
		}
		uc = get_action_sw();									// XCb`Ԃ
		uc = uc & 0x0f;											// XCb`ɂ
		if(uc == SWR_OFF_LONG){									// ꂽ
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HM;
			old_RTC_hou = 0xff;
			old_RTC_min = 0xff;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}else if(uc == SWR_OFF_SHORT){							// Zꂽ
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				break;
			 case MD:
				disp_clock_mode = YE;
				old_RTC_year = 0xff;
				break;
			 case YE:
				disp_clock_mode = A_D;
				old_AD_data = 0xffff;
				break;
			 case A_D:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			 default:
				disp_clock_mode = HM;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){					// qsbĂ鎞̂Pboߗp
				old_rtc_1s_flg = rtc_1s_flg;
				bright = ad1_get_data();						// A/D1i邳j 擾
				if(disp_clock_mode == A_D){						// `cf[^\̎
					if(old_AD_data != bright){					// `^cf[^ω
						wtod_04bcd(num_data, bright);
						chang_7seg_data(num_data,dp_data);		//  VZOf[^֕ϊS
						old_AD_data = bright;
					}
				}else{
					rtc_read();										// RTC ǂݏo
					if(disp_clock_mode == HM){						// \̎
						tim_10ms_led = 50;							// TOOr^C}[d|
						set_7seg_dp(1, 1);							// kdc_
						if((old_RTC_hou != gRTC_hou)||(old_RTC_min != gRTC_min)){	// ω
							set_7seg_data(gRTC_hou >> 4,0,0);		// \
							set_7seg_data(gRTC_hou & 0x0f,1,1);
							set_7seg_data(gRTC_min >> 4,0,2);		// \
							set_7seg_data(gRTC_min & 0x0f,0,3);
							old_RTC_hou = gRTC_hou;
							old_RTC_min = gRTC_min;
						}
					}else if(disp_clock_mode == MD){				// \̎
						if((old_RTC_mon != gRTC_mon)||(old_RTC_day != gRTC_day)){	// ω
							set_7seg_data(gRTC_mon >> 4,0,0);		// \
							set_7seg_data(gRTC_mon & 0x0f,1,1);
							set_7seg_data(gRTC_day >> 4,0,2);		// \
							set_7seg_data(gRTC_day & 0x0f,0,3);
							old_RTC_mon = gRTC_mon;
							old_RTC_day = gRTC_day;
						}
					}else if(disp_clock_mode == YE){				// N\̎
						if(old_RTC_year != gRTC_year){				// Nω
							set_7seg_data(2,0,0);
							set_7seg_data(0,0,1);
							set_7seg_data(gRTC_year >> 4,0,2);		// N\
							set_7seg_data(gRTC_year & 0x0f,1,3);
							old_RTC_year = gRTC_year;
						}
					}
				}

				if (proc_no_key_timeup(0) == 0xff){				// ԃL[͂
					if(disp_clock_mode != HM){					// \Ŗ
						disp_clock_mode = HM;
						old_RTC_hou = 0xff;
						old_RTC_min = 0xff;
					}
				}

				if(500 > bright){								// ͂邢
					set_7seg_bright(2);							// VZO\̖邳ݒiԖ邢j
				}else if(600 > bright){							// ͂炢
					set_7seg_bright(1);							// VZO\̖邳ݒi炢j
				}else{											// ͂Â
					set_7seg_bright(0);							// VZO\̖邳ݒiԈÂj
				}
			}
			if((tim_10ms_led == 0) && (disp_clock_mode == HM)){	// \̎ɂTOOro߂
				set_7seg_dp(0, 1);								// kdc
			}
		}
		sleep_mode();											// X[vڍs
	}
}
