//*******************************************************
// RTC & 7seg LED Program Mega88
//  file name: disp_7seg_led.c
//@@@SVZOkdcɃ_Ci~bN\
//@@@PD4:7seg.-DIG1(Left Side)  1=Lighting
//@@@PD5:7seg.-DIG2             1=Lighting
//@@@PD6:7seg.-DIG3             1=Lighting
//@@@PD7:7seg.-DIG4             1=Lighting
//@@@PB0:7seg.-a                0=Lighting
//@@@PB1:7seg.-b                0=Lighting
//@@@PC2:7seg.-c                0=Lighting
//@@@PC3:7seg.-d                0=Lighting
//@@@PC4:7seg.-e                0=Lighting
//@@@PC5:7seg.-f                0=Lighting
//@@@PB6:7seg.-g                0=Lighting
//@@@PB7:7seg.-dp               0=Lighting
//
//  2014/01/29  New(TAB4)  Taishi
//*******************************************************

#include	<avr/io.h>

#include	"RTC_7SEG.h"
#include	"disp_7seg_led.h"

#define	SEG7_DUTY_MAX		6									// \Ԃɋ؂邩iݎԂƃ`cLŌ߂j
#define	SEG7_OFF_MAX		(SEG7_DUTY_MAX-1)					// \Ԓ̂neeɂ銄̍ől
#define	SEG7_OFF_MIN		0									// \Ԓ̂neeɂ銄̍ŏl
#define	SEG7_OFF_HIGH		SEG7_OFF_MAX							// \Ԗ邭鎞
#define	SEG7_OFF_MID		3									// \𒆂炢鎞
#define	SEG7_OFF_LOW		0									// \ԈÂ鎞

static	unsigned char	seg7_enable = 0;						// 0=VZO\Ȃ
static	unsigned char	seg7_off_duty = SEG7_OFF_HIGH;			// \Ԓ̂neeɂ銄i邳ςj

static	unsigned char	seg7_data[4] ={0xff,0xff,0xff,0xff};	// \Vf[^

static	const unsigned char	hex_to_7seg[16]={
		// D7;dp, D6:g, D5:f, D4:e, D3:d, D2:c, D1:b, D0:a
		0b00111111,				// 0
		0b00000110,				// 1
		0b01011011,				// 2
		0b01001111,				// 3
		0b01100110,				// 4
		0b01101101,				// 5
		0b01111101,				// 6
		0b00000111,				// 7
		0b01111111,				// 8
		0b01101111,				// 9
		0b01110111,				// A
		0b01111100,				// B
		0b01011000,				// C
		0b01011110,				// D
		0b01111001,				// E
		0b01110001,				// F
};

// *****************************
//  VZOp̏ݒ
//  @ Ȃ
//
//  |[g(rbg)ݒ肷
//@@@PD4:7seg.-DIG1(Left Side)  1=Lighting
//@@@PD5:7seg.-DIG2             1=Lighting
//@@@PD6:7seg.-DIG3             1=Lighting
//@@@PD7:7seg.-DIG4             1=Lighting
//@@@PB0:7seg.-a                0=Lighting
//@@@PB1:7seg.-b                0=Lighting
//@@@PC2:7seg.-c                0=Lighting
//@@@PC3:7seg.-d                0=Lighting
//@@@PC4:7seg.-e                0=Lighting
//@@@PC5:7seg.-f                0=Lighting
//@@@PB6:7seg.-g                0=Lighting
//@@@PB7:7seg.-dp               0=Lighting
//  2014/01/29 New   Taishi
// *****************************
void	init_7seg(void)
{
	DDRB  |= ((1 << DDB0) | (1 << DDB1) | (1 << DDB6) | (1 << DDB7) );	// ZOg̃rbgo͂ɂ
	PORTB |= ((1 << PB0) | (1 << PB1) | (1 << PB6) | (1 << PB7) );		// ZOgf[^Fgij
	DDRC  |= ((1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5) );	// ZOg̃rbgo͂ɂ
	PORTC |= ((1 << PC2) | (1 << PC3) | (1 << PC4) | (1 << PC5) );		// ZOgf[^Fgij
	DDRD  |= ((1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7) );	// R̃rbgo͂ɂ
	PORTD &= ~((1 << PD4) | (1 << PD5) | (1 << PD6) | (1 << PD7) );		// Rf[^Fkij

	seg7_enable = 0;						// 0=VZO\Ȃ
}
// *****************************
//  VZO\̗L̃Zbg
// *****************************
void	set_7seg_enable(void)
{
	seg7_enable = 1;				// VZO\s
}
// *****************************
//  VZO\̖̃Zbg
// *****************************
void	set_7seg_disable(void)
{
	seg7_enable = 0;				// VZO\sȂ
}
// *****************************
//  VZOf[^̃Zbg
//  @
//@@@@FPUiiO`PTAPUȏ̓uNj
//@@@F̏ԁ@OAP_
//@@@@FwiO`RAOōj
//
//  2014/01/29 New   Taishi
// *****************************
void set_7seg_data(unsigned char h, unsigned char dp, unsigned char n)
{
	unsigned char	seg;

	if(16 <= h){
		seg = 0;						// uN
	}else{
		seg = hex_to_7seg[h & 0x0f];	// PUiVZOf[^ɕϊ
	}
	if(dp != 0){
		seg |= 0x80;					// ǉ
	}
	seg ^= 0xff;						// ]

	seg7_data[n & 0x03] = seg;			// \Vf[^ɓ

}
// *****************************
//  VZOf[^֕ϊS
//  @
//@@@@strFŜPUiiO`PTj̃|C^[
//@@@@ dpFŜỉEj̃|C^[
//
//@@ŜPUi͉SrbgL
//  2014/01/29 New   Taishi
// *****************************
void	chang_7seg_data(unsigned char *str,unsigned char *dp)
{
	unsigned char	i;

	for(i=0;i<4;i++){
		set_7seg_data(*(str+i), *(dp+i), i);		//  VZOf[^̃Zbg
	}
}
// *****************************
//  VZOf[^̂𒼐ڃZbg
//  @
//@@@F̏ԁ@OAP_
//@@@@FwiO`RAOj
//
//  2014/01/29 New   Taishi
// *****************************
void	set_7seg_dp(unsigned char dp, unsigned char n)
{
	if(dp != 0){
		seg7_data[n & 0x03] &= ~0x80;		// _
	}else{
		seg7_data[n & 0x03] |=  0x80;		// 
	}
}

// *****************************
//  VZO\̖邳ݒ肷
//  @
//@@@@F邳iOFԈÂAPF炢AQFԖ邢j
//
//  2014/02/20 New   Taishi
// *****************************
void	set_7seg_bright(unsigned char n)
{
	if(n == 0){
		seg7_off_duty = SEG7_OFF_LOW;			// ԈÂ
	}else if(n == 1){
		seg7_off_duty = SEG7_OFF_MID;			// 炢
	}else{
		seg7_off_duty = SEG7_OFF_HIGH;			// Ԗ邢
	}
}
// *****************************
//  VZȌo
//  @
//@@@@FZOgf[^
//                D7;dp, D6:g, D5:f, D4:e, D3:d, D2:c, D1:b, D0:a
//
//  \߃|[g̐ݒ͍sĂ̂Ƃ
//  ZOgf[^̓n[h̓_A̘_ƈvĂ镨Ƃ
//@@@PB0:7seg.-a                0=Lighting
//@@@PB1:7seg.-b                0=Lighting
//@@@PC2:7seg.-c                0=Lighting
//@@@PC3:7seg.-d                0=Lighting
//@@@PC4:7seg.-e                0=Lighting
//@@@PC5:7seg.-f                0=Lighting
//@@@PB6:7seg.-g                0=Lighting
//@@@PB7:7seg.-dp               0=Lighting
//  2014/01/29 New   Taishi
// *****************************
static
void output_7seg(unsigned char seg)
{
	unsigned char	uc;

	PORTB |= ( (1 << PB0) | (1 << PB1) | (1 << PB6) | (1 << PB7) );		// xSď̏Ԃɂ
	PORTC |= ( (1 << PC2) | (1 << PC3) | (1 << PC4) | (1 << PC5) );

	uc = ( seg | ((1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB5)) );	// oâVZO
	PORTB &= uc;														// oâVZOo

	uc = ( seg | ((1 << PC0) | (1 << PC1) | (1 << PC6)) );				// ob̂VZO
	PORTC &= uc;														// ob̂VZOo

}

// *****************************
//  VZO̕\
//  K莞(200uS -- 1mS)̊荞ݒŌĂ΂镨Ƃ
//@@@PD4:7seg.-DIG1(Left Side)  1=Lighting
//@@@PD5:7seg.-DIG2             1=Lighting
//@@@PD6:7seg.-DIG3             1=Lighting
//@@@PD7:7seg.-DIG4             1=Lighting
//  2014/01/29 New   Taishi
// *****************************
void	disp_7seg(void)
{
	static	unsigned char	keta=0;
	static	unsigned char	pre_scale=0;
	static	unsigned char	dig_bit[4]={(1 << PD4),(1 << PD5),(1 << PD6),(1 << PD7)};	// ɑΉchfrbg

	if((SEG7_DUTY_MAX-1) <= pre_scale){
		if(seg7_enable != 0){
			PORTD &= ~((1 << PD4)|(1 << PD5)|(1 << PD6)|(1 << PD7));	// xRSĂneeɂ
			output_7seg(seg7_data[keta]);								// VZȌo
			PORTD |= dig_bit[keta];										// Rnm
			keta++;														// i߂
			keta &= 0x03;

			pre_scale = 0;
		}
	}else{
		if(seg7_off_duty <= pre_scale){
			PORTD &= ~((1 << PD4)|(1 << PD5)|(1 << PD6)|(1 << PD7));	// RSĂneeɂ
		}
		pre_scale++;
	}
}
